diff -pru mailman-cvs-HEAD/Mailman/Archiver/Archiver.py mailman-2.1.7.cg/Mailman/Archiver/Archiver.py
--- mailman-cvs-HEAD/Mailman/Archiver/Archiver.py	2005-08-28 07:31:26.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Archiver/Archiver.py	2006-03-08 18:05:58.000000000 +0100
@@ -24,7 +24,6 @@ archival.
 
 import os
 import errno
-import traceback
 import re
 from cStringIO import StringIO
 
@@ -46,6 +45,17 @@ except NameError:
 
 def makelink(old, new):
     try:
+        # Before symlinking, make sure that the directory where the
+        # symlink will be created exists.
+        omask = os.umask(0)
+        try:
+            try:
+                os.makedirs(os.path.split(new)[0], 02775)
+            except OSError, e:
+                if e.errno <> errno.EEXIST:
+                    raise
+        finally:
+            os.umask(omask)
         os.symlink(old, new)
     except OSError, e:
         if e.errno <> errno.EEXIST:
@@ -80,9 +90,17 @@ class Archiver:
         #             listname.mbox
         #         listname/
         #             lots-of-pipermail-stuff
+        #         domain.com/
+        #             listname.mbox/
+        #                 listname.mbox
+        #             listname/
+        #                 lots-of-pipermail-stuff
         #     public/
         #         listname.mbox@ -> ../private/listname.mbox
         #         listname@ -> ../private/listname
+        #         domain.com/
+        #             listname.mbox@ -> ../../private/listname.mbox
+        #             listname@ -> ../../private/listname
         #
         # IOW, the mbox and pipermail archives are always stored in the
         # private archive for the list.  This is safe because archives/private
@@ -93,7 +111,7 @@ class Archiver:
         omask = os.umask(0)
         try:
             try:
-                os.mkdir(self.archive_dir()+'.mbox', 02775)
+                os.makedirs(self.archive_dir()+'.mbox', 02775)
             except OSError, e:
                 if e.errno <> errno.EEXIST: raise
                 # We also create an empty pipermail archive directory into
@@ -101,7 +119,7 @@ class Archiver:
                 # that lists that have not yet received a posting have
                 # /something/ as their index.html, and don't just get a 404.
             try:
-                os.mkdir(self.archive_dir(), 02775)
+                os.makedirs(self.archive_dir(), 02775)
             except OSError, e:
                 if e.errno <> errno.EEXIST: raise
             # See if there's an index.html file there already and if not,
@@ -132,8 +150,7 @@ class Archiver:
 
     def ArchiveFileName(self):
         """The mbox name where messages are left for archive construction."""
-        return os.path.join(self.archive_dir() + '.mbox',
-                            self.internal_name() + '.mbox')
+        return Site.get_mboxpath(self.internal_name())
 
     def GetBaseArchiveURL(self):
         url = self.GetScriptURL('private', absolute=1) + '/'
@@ -143,7 +160,7 @@ class Archiver:
             hostname = re.match('[^:]*://([^/]*)/.*', url).group(1)\
                        or mm_cfg.DEFAULT_URL_HOST
             url = mm_cfg.PUBLIC_ARCHIVE_URL % {
-                'listname': self.internal_name(),
+                'listname': self.local_part,
                 'hostname': hostname
                 }
             if not url.endswith('/'):
diff -pru mailman-cvs-HEAD/Mailman/Archiver/HyperArch.py mailman-2.1.7.cg/Mailman/Archiver/HyperArch.py
--- mailman-cvs-HEAD/Mailman/Archiver/HyperArch.py	2006-01-29 06:13:57.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Archiver/HyperArch.py	2006-03-10 10:36:33.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -52,6 +52,7 @@ from Mailman import i18n
 from Mailman.SafeDict import SafeDict
 from Mailman.Logging.Syslog import syslog
 from Mailman.Mailbox import ArchiverMailbox
+from Mailman import Site
 
 # Set up i18n.  Assume the current language has already been set in the caller.
 _ = i18n._
@@ -304,7 +305,12 @@ class Article(pipermail.Article):
             if charset[0]=="'" and charset[-1]=="'":
                 charset = charset[1:-1]
             try:
-                body = message.get_payload(decode=True)
+                # Check Scrubber-munged payload
+                if message.get('x-mailman-scrubbed'):
+                    decode = False
+                else:
+                    decode = True
+                body = message.get_payload(decode=decode)
             except binascii.Error:
                 body = None
             if body and charset != Utils.GetCharSet(self._lang):
@@ -748,11 +754,11 @@ class HyperArchive(pipermail.T):
 
     def html_TOC(self):
         mlist = self.maillist
-        listname = mlist.internal_name()
-        mbox = os.path.join(mlist.archive_dir()+'.mbox', listname+'.mbox')
+        local_part = mlist.local_part
+        mbox = Site.get_mboxpath(mlist.internal_name())
         d = {"listname": mlist.real_name,
              "listinfo": mlist.GetScriptURL('listinfo', absolute=1),
-             "fullarch": '../%s.mbox/%s.mbox' % (listname, listname),
+             "fullarch": '../%s.mbox/%s.mbox' % (local_part, local_part), # NDIM XXX Path
              "size": sizeof(mbox, mlist.preferred_language),
              'meta': '',
              }
@@ -830,7 +836,7 @@ class HyperArchive(pipermail.T):
             return 1
         self._lock_file = LockFile.LockFile(
             os.path.join(mm_cfg.LOCK_DIR,
-                         self.maillist.internal_name() + '-arch.lock'))
+                         self.maillist.internal_name() + '-arch.lock')) # NDIM XXX Lock
         try:
             self._lock_file.lock(timeout=0.5)
         except LockFile.TimeOutError:
diff -pru mailman-cvs-HEAD/Mailman/Archiver/pipermail.py mailman-2.1.7.cg/Mailman/Archiver/pipermail.py
--- mailman-cvs-HEAD/Mailman/Archiver/pipermail.py	2006-01-29 06:13:57.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Archiver/pipermail.py	2005-12-26 02:22:08.000000000 +0100
@@ -21,6 +21,13 @@ from Mailman.Mailbox import ArchiverMail
 from Mailman.Logging.Syslog import syslog
 from Mailman.i18n import _
 
+# True/False
+try:
+    True, False
+except NameError:
+    True = 1
+    False = 0
+
 SPACE = ' '
 
 
@@ -217,7 +224,12 @@ class Article:
                 self.headers[i] = message[i]
 
         # Read the message body
-        s = StringIO(message.get_payload(decode=True)\
+        # Check Scrubber-munged paylaod
+        if message.get('x-mailman-scrubbed'):
+            decode = False
+        else:
+            decode = True
+        s = StringIO(message.get_payload(decode=decode)\
                      or message.as_string().split('\n\n',1)[1])
         self.body = s.readlines()
 
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/BouncerAPI.py mailman-2.1.7.cg/Mailman/Bouncers/BouncerAPI.py
--- mailman-cvs-HEAD/Mailman/Bouncers/BouncerAPI.py	2006-03-01 03:34:54.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/BouncerAPI.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998,1999,2000,2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Contains all the common functionality for msg bounce scanning API.
 
@@ -63,7 +62,10 @@ def ScanMessages(mlist, msg):
         modname = 'Mailman.Bouncers.' + module
         __import__(modname)
         addrs = sys.modules[modname].process(msg)
-        if addrs:
-            # Return addrs even if it is Stop. BounceRunner needs this info.
+        if addrs is Stop:
+            # One of the detectors recognized the bounce, but there were no
+            # addresses to extract.  Return the empty list.
+            return []
+        elif addrs:
             return addrs
     return []
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/Caiwireless.py mailman-2.1.7.cg/Mailman/Bouncers/Caiwireless.py
--- mailman-cvs-HEAD/Mailman/Bouncers/Caiwireless.py	2006-03-10 11:36:00.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/Caiwireless.py	2005-08-27 03:40:15.000000000 +0200
@@ -27,7 +27,7 @@ acre = re.compile(r'<(?P<addr>[^>]*)>')
 
 
 def process(msg):
-    if msg.get_content_type() <> 'multipart/mixed':
+    if msg.get_type() <> 'multipart/mixed':
         return None
     # simple state machine
     #     0 == nothing seen
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/DSN.py mailman-2.1.7.cg/Mailman/Bouncers/DSN.py
--- mailman-cvs-HEAD/Mailman/Bouncers/DSN.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/DSN.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Parse RFC 3464 (i.e. DSN) bounce formats.
 
@@ -53,10 +52,9 @@ def check(msg):
             #
             # Also grok out Action so we can do something with that too.
             action = msgblock.get('action', '').lower()
-            # Some MTAs have been observed that put comments on the action.
-            if action.startswith('delayed'):
+            if action == 'delayed':
                 return Stop
-            if not action.startswith('fail'):
+            if action not in ('failed', 'failure'):
                 # Some non-permanent failure, so ignore this block
                 continue
             params = []
@@ -85,6 +83,6 @@ def process(msg):
     # The report-type parameter should be "delivery-status", but it seems that
     # some DSN generating MTAs don't include this on the Content-Type: header,
     # so let's relax the test a bit.
-    if not msg.is_multipart() or msg.get_content_subtype() <> 'report':
+    if not msg.is_multipart() or msg.get_subtype() <> 'report':
         return None
     return check(msg)
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/GroupWise.py mailman-2.1.7.cg/Mailman/Bouncers/GroupWise.py
--- mailman-cvs-HEAD/Mailman/Bouncers/GroupWise.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/GroupWise.py	2005-08-27 03:40:15.000000000 +0200
@@ -30,7 +30,7 @@ acre = re.compile(r'<(?P<addr>[^>]*)>')
 
 
 def find_textplain(msg):
-    if msg.get_content_type() == 'text/plain':
+    if msg.get_type(msg.get_default_type()) == 'text/plain':
         return msg
     if msg.is_multipart:
         for part in msg.get_payload():
@@ -44,7 +44,7 @@ def find_textplain(msg):
 
 
 def process(msg):
-    if msg.get_content_type() <> 'multipart/mixed' or not msg['x-mailer']:
+    if msg.get_type() <> 'multipart/mixed' or not msg['x-mailer']:
         return None
     addrs = {}
     # find the first text/plain part in the message
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/Microsoft.py mailman-2.1.7.cg/Mailman/Bouncers/Microsoft.py
--- mailman-cvs-HEAD/Mailman/Bouncers/Microsoft.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/Microsoft.py	2005-08-27 03:40:15.000000000 +0200
@@ -25,7 +25,7 @@ scre = re.compile(r'transcript of sessio
 
 
 def process(msg):
-    if msg.get_content_type() <> 'multipart/mixed':
+    if msg.get_type() <> 'multipart/mixed':
         return None
     # Find the first subpart, which has no MIME type
     try:
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/Netscape.py mailman-2.1.7.cg/Mailman/Bouncers/Netscape.py
--- mailman-cvs-HEAD/Mailman/Bouncers/Netscape.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/Netscape.py	2005-08-27 03:40:15.000000000 +0200
@@ -61,7 +61,7 @@ def process(msg):
     leaves = []
     flatten(msg, leaves)
     for i, subpart in zip(range(len(leaves)-1), leaves):
-        if subpart.get_content_type() == 'text/plain':
+        if subpart.get_type() == 'text/plain':
             plainmsg = subpart
             break
     if not plainmsg:
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/Postfix.py mailman-2.1.7.cg/Mailman/Bouncers/Postfix.py
--- mailman-cvs-HEAD/Mailman/Bouncers/Postfix.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/Postfix.py	2005-08-27 03:40:15.000000000 +0200
@@ -71,14 +71,14 @@ def findaddr(msg):
 
 
 def process(msg):
-    if msg.get_content_type() not in ('multipart/mixed', 'multipart/report'):
+    if msg.get_type() not in ('multipart/mixed', 'multipart/report'):
         return None
     # We're looking for the plain/text subpart with a Content-Description: of
     # `notification'.
     leaves = []
     flatten(msg, leaves)
     for subpart in leaves:
-        if subpart.get_content_type() == 'text/plain' and \
+        if subpart.get_type() == 'text/plain' and \
            subpart.get('content-description', '').lower() == 'notification':
             # then...
             return findaddr(subpart)
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/SimpleMatch.py mailman-2.1.7.cg/Mailman/Bouncers/SimpleMatch.py
--- mailman-cvs-HEAD/Mailman/Bouncers/SimpleMatch.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SimpleMatch.py	2006-02-21 07:21:11.000000000 +0100
@@ -78,31 +78,7 @@ PATTERNS = [
     # Prodigy.net full mailbox
     (_c("User's mailbox is full:"),
      _c('Unable to deliver mail.'),
-     _c("User's mailbox is full:\s*<(?P<addr>[^>]*)>")),
-    # Microsoft SMTPSVC
-    (_c('The email below could not be delivered to the following user:'),
-     _c('Old message:'),
-     _c('<(?P<addr>[^>]*)>')),
-    # Yahoo on behalf of other domains like sbcglobal.net
-    (_c('Unable to deliver message to the following address\(es\)\.'),
-     _c('--- Original message follows\.'),
-     _c('<(?P<addr>[^>]*)>:')),
-    # kundenserver.de
-    (_c('A message that you sent could not be delivered'),
-     _c('^--- The header of the original'),
-     _c('<(?P<addr>[^>]*)>')),
-    # another kundenserver.de
-    (_c('A message that you sent could not be delivered'),
-     _c('^--- The header of the original'),
-     _c('^(?P<addr>[^\s@]+@[^\s@:]+):')),
-    # thehartford.com
-    (_c('Delivery to the following recipients failed'),
-     _c("Bogus - there actually isn't anything"),
-     _c('^\s*(?P<addr>[^\s@]+@[^\s@]+)\s*$')),
-    # and another thehartfod.com/hartfordlife.com
-    (_c('^Your message'),
-     _c('^because:'),
-     _c('^\s*(?P<addr>[^\s@]+@[^\s@]+)\s*$')),
+     _c("User's mailbox is full:\s*<(?P<addr>.*)>.*$")),
     # Next one goes here...
     ]
 
@@ -115,27 +91,19 @@ def process(msg, patterns=None):
     #     0 = nothing seen yet
     #     1 = intro seen
     addrs = {}
-    # MAS: This is a mess. The outer loop used to be over the message
-    # so we only looped through the message once.  Looping through the
-    # message for each set of patterns is obviously way more work, but
-    # if we don't do it, problems arise because scre from the wrong
-    # pattern set matches first and then acre doesn't match.  The
-    # alternative is to split things into separate modules, but then
-    # we process the message multiple times anyway.
-    for scre, ecre, acre in patterns:
-        state = 0
-        for line in email.Iterators.body_line_iterator(msg):
-            if state == 0:
+    state = 0
+    for line in email.Iterators.body_line_iterator(msg):
+        if state == 0:
+            for scre, ecre, acre in patterns:
                 if scre.search(line):
                     state = 1
-            if state == 1:
-                mo = acre.search(line)
-                if mo:
-                    addr = mo.group('addr')
-                    if addr:
-                        addrs[mo.group('addr')] = 1
-                elif ecre.search(line):
                     break
-        if addrs:
-            break
+        if state == 1:
+            mo = acre.search(line)
+            if mo:
+                addr = mo.group('addr')
+                if addr:
+                    addrs[mo.group('addr')] = 1
+            elif ecre.search(line):
+                break
     return addrs.keys()
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/SimpleWarning.py mailman-2.1.7.cg/Mailman/Bouncers/SimpleWarning.py
--- mailman-cvs-HEAD/Mailman/Bouncers/SimpleWarning.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SimpleWarning.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,12 +12,10 @@
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software 
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Recognizes simple heuristically delimited warnings."""
 
-from Mailman.Bouncers.BouncerAPI import Stop
 from Mailman.Bouncers.SimpleMatch import _c
 from Mailman.Bouncers.SimpleMatch import process as _process
 
@@ -43,8 +41,4 @@ patterns = [
 
 
 def process(msg):
-    if _process(msg, patterns):
-        # It's a recognized warning so stop now
-        return Stop
-    else:
-        return []
+    return _process(msg, patterns)
diff -pru mailman-cvs-HEAD/Mailman/Bouncers/SMTP32.py mailman-2.1.7.cg/Mailman/Bouncers/SMTP32.py
--- mailman-cvs-HEAD/Mailman/Bouncers/SMTP32.py	2006-02-05 20:47:33.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SMTP32.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998,1999,2000,2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software 
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Something which claims
 X-Mailer: <SMTP32 vXXXXXX>
@@ -36,8 +35,7 @@ acre = re.compile(r'''
     (                                             # several different prefixes
     user\ mailbox[^:]*:                           # have been spotted in the
     |delivery\ failed[^:]*:                       # wild...
-    |unknown\ user[^:]*:
-    |undeliverable\ +to
+    |undeliverable\ to
     )
     \s*                                           # space separator
     (?P<addr>.*)                                  # and finally, the address
diff -pru mailman-cvs-HEAD/Mailman/Cgi/admindb.py mailman-2.1.7.cg/Mailman/Cgi/admindb.py
--- mailman-cvs-HEAD/Mailman/Cgi/admindb.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/admindb.py	2006-03-10 16:07:26.000000000 +0100
@@ -81,7 +81,7 @@ def main():
         handle_no_list()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-HEAD/Mailman/Cgi/admin.py mailman-2.1.7.cg/Mailman/Cgi/admin.py
--- mailman-cvs-HEAD/Mailman/Cgi/admin.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/admin.py	2006-03-10 16:07:19.000000000 +0100
@@ -65,8 +65,9 @@ def main():
         # None, so just do the admin overview and be done with it
         admin_overview()
         return
+
     # Get the list object
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
@@ -418,7 +419,7 @@ def show_results(mlist, doc, category, s
                        '<br>&nbsp;<br>')
     # We do not allow through-the-web deletion of the site list!
     if mm_cfg.OWNERS_CAN_DELETE_THEIR_OWN_LISTS and \
-           mlist.internal_name() <> mm_cfg.MAILMAN_SITE_LIST:
+           mlist.local_name <> mm_cfg.MAILMAN_SITE_LIST:
         otherlinks.AddItem(Link(mlist.GetScriptURL('rmlist'),
                                 _('Delete this mailing list')).Format() +
                            _(' (requires confirmation)<br>&nbsp;<br>'))
diff -pru mailman-cvs-HEAD/Mailman/Cgi/confirm.py mailman-2.1.7.cg/Mailman/Cgi/confirm.py
--- mailman-cvs-HEAD/Mailman/Cgi/confirm.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/confirm.py	2006-03-10 16:07:37.000000000 +0100
@@ -53,7 +53,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-HEAD/Mailman/Cgi/edithtml.py mailman-2.1.7.cg/Mailman/Cgi/edithtml.py
--- mailman-cvs-HEAD/Mailman/Cgi/edithtml.py	2006-01-09 08:04:57.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/edithtml.py	2006-03-10 16:07:53.000000000 +0100
@@ -61,7 +61,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-HEAD/Mailman/Cgi/listinfo.py mailman-2.1.7.cg/Mailman/Cgi/listinfo.py
--- mailman-cvs-HEAD/Mailman/Cgi/listinfo.py	2005-08-28 07:31:26.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/listinfo.py	2006-03-10 16:08:07.000000000 +0100
@@ -42,7 +42,7 @@ def main():
         listinfo_overview()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-HEAD/Mailman/Cgi/options.py mailman-2.1.7.cg/Mailman/Cgi/options.py
--- mailman-cvs-HEAD/Mailman/Cgi/options.py	2005-12-03 02:09:50.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/options.py	2006-03-10 16:08:20.000000000 +0100
@@ -65,7 +65,7 @@ def main():
         return
 
     # get the list and user's name
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     # open list
     try:
         mlist = MailList.MailList(listname, lock=0)
diff -pru mailman-cvs-HEAD/Mailman/Cgi/private.py mailman-2.1.7.cg/Mailman/Cgi/private.py
--- mailman-cvs-HEAD/Mailman/Cgi/private.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/private.py	2006-04-16 02:20:50.000000000 +0200
@@ -29,6 +29,7 @@ from Mailman import Errors
 from Mailman import i18n
 from Mailman.htmlformat import *
 from Mailman.Logging.Syslog import syslog
+from Mailman.Site import get_mboxpath
 
 # Set up i18n.  Until we know which list is being requested, we use the
 # server's default.
@@ -79,7 +80,7 @@ def main():
     true_filename = os.path.join(
         mm_cfg.PRIVATE_ARCHIVE_FILE_DIR, tpath)
 
-    listname = parts[0].lower()
+    listname = parts[0].lower() # NDIM XXX use Utils.GetListname
     mboxfile = ''
     if len(parts) > 1:
         mboxfile = parts[1]
@@ -166,8 +167,7 @@ def main():
         if ctype is None:
             ctype = 'text/html'
         if mboxfile:
-            f = open(os.path.join(mlist.archive_dir() + '.mbox',
-                                  mlist.internal_name() + '.mbox'))
+            f = open(get_mboxpath(mlist.internal_name()))
             ctype = 'text/plain'
         elif true_filename.endswith('.gz'):
             import gzip
diff -pru mailman-cvs-HEAD/Mailman/Cgi/rmlist.py mailman-2.1.7.cg/Mailman/Cgi/rmlist.py
--- mailman-cvs-HEAD/Mailman/Cgi/rmlist.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/rmlist.py	2006-03-10 16:09:01.000000000 +0100
@@ -55,7 +55,7 @@ def main():
         syslog('error', 'Bad URL specification: %s', parts)
         return
         
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
@@ -136,8 +136,9 @@ def process_request(doc, cgidata, mlist)
 
     problems = 0
     listname = mlist.internal_name()
+    local_part = mlist.local_part
     for dirtmpl in REMOVABLES:
-        dir = os.path.join(mm_cfg.VAR_PREFIX, dirtmpl % listname)
+        dir = os.path.join(mm_cfg.VAR_PREFIX, dirtmpl % local_part) # NDIM XXX
         if os.path.islink(dir):
             try:
                 os.unlink(dir)
diff -pru mailman-cvs-HEAD/Mailman/Cgi/roster.py mailman-2.1.7.cg/Mailman/Cgi/roster.py
--- mailman-cvs-HEAD/Mailman/Cgi/roster.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/roster.py	2006-03-10 16:09:10.000000000 +0100
@@ -48,7 +48,7 @@ def main():
         error_page(_('Invalid options to CGI script'))
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-HEAD/Mailman/Cgi/subscribe.py mailman-2.1.7.cg/Mailman/Cgi/subscribe.py
--- mailman-cvs-HEAD/Mailman/Cgi/subscribe.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/subscribe.py	2006-03-10 16:09:20.000000000 +0100
@@ -51,7 +51,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
